unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_KCRLLTZ, U_MarkingInspection, U_GreyInspection,
  U_ClothSCDCGAnPai, U_CiPinChaiJian;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);
  if Trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
    dtbase := 'yiduidata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';

//    server := '.';
//    dtbase := 'yiduidata';
//    user := 'sa';
//    pswd := 'rightsoft';

    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;

    // DName:='徐水娟';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    301:  //布票打印
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '布票打印' then
          begin
            BringWindowToTop(frmClothSCDCGAnPai.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmClothSCDCGAnPai := TfrmClothSCDCGAnPai.Create(application.MainForm);
          with frmClothSCDCGAnPai do
          begin
            Title := '布票打印';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmClothSCDCGAnPai.BringToFront;
       //句柄
        mnewHandle := frmClothSCDCGAnPai.Handle;
      end;
    111:  //梭织坯布检验
      begin
        if frmGreyInspection = nil then
        begin
          frmGreyInspection := TfrmGreyInspection.Create(application.MainForm);
          with frmGreyInspection do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGreyInspection.BringToFront;
       //句柄
        mnewHandle := frmGreyInspection.Handle;
      end;
    1:  //开剪
      begin
        if frmCiPinChaiJian = nil then
        begin
          frmCiPinChaiJian := TfrmCiPinChaiJian.Create(application.MainForm);
          with frmCiPinChaiJian do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCiPinChaiJian.BringToFront;
       //句柄
        mnewHandle := frmCiPinChaiJian.Handle;
      end;
    311:  //成品检验
      begin
        if frmMarkingInspection = nil then
        begin
          frmMarkingInspection := TfrmMarkingInspection.Create(application.MainForm);
          with frmMarkingInspection do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMarkingInspection.BringToFront;
       //句柄
        mnewHandle := frmMarkingInspection.Handle;
      end;

    321: // 布匹拆分合并
      begin
        if frmKCRLLTZ = nil then
        begin
          frmKCRLLTZ := TfrmKCRLLTZ.Create(application.MainForm);
          with frmKCRLLTZ do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
          end;
        end
        else
          frmKCRLLTZ.BringToFront;
       //句柄
        mnewHandle := frmKCRLLTZ.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_FabricInspection) then
    DataLink_FabricInspection := TDataLink_FabricInspection.Create(Application);
  try
    with DataLink_FabricInspection.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_FabricInspection.Free;
//  Application := OldDllApp;
initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_FabricInspection.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

